<?php


abstract class BaseControlComisPeer {

	
	const DATABASE_NAME = 'propel';

	
	const TABLE_NAME = 'CONTROL_COMIS';

	
	const CLASS_DEFAULT = 'lib.model.ControlComis';

	
	const NUM_COLUMNS = 7;

	
	const NUM_LAZY_LOAD_COLUMNS = 0;


	
	const ID = 'CONTROL_COMIS.ID';

	
	const TIPCOM = 'CONTROL_COMIS.TIPCOM';

	
	const DIAS = 'CONTROL_COMIS.DIAS';

	
	const DOCUMENTO = 'CONTROL_COMIS.DOCUMENTO';

	
	const FECHA = 'CONTROL_COMIS.FECHA';

	
	const OBSERVACIONES = 'CONTROL_COMIS.OBSERVACIONES';
        
        const ESTADO = 'CONTROL_COMIS.ESTADO';

	
	private static $phpNameMap = null;


	
	private static $fieldNames = array (
		BasePeer::TYPE_PHPNAME => array ('Id', 'Tipcom', 'Dias', 'Documento', 'Fecha', 'Observaciones','Estado' ),
		BasePeer::TYPE_COLNAME => array (ControlComisPeer::ID, ControlComisPeer::TIPCOM, ControlComisPeer::DIAS, ControlComisPeer::DOCUMENTO, ControlComisPeer::FECHA, ControlComisPeer::OBSERVACIONES,ControlComisPeer::ESTADO, ),
		BasePeer::TYPE_FIELDNAME => array ('ID', 'TIPCOM', 'DIAS', 'DOCUMENTO', 'FECHA', 'OBSERVACIONES','ESTADO', ),
		BasePeer::TYPE_NUM => array (0, 1, 2, 3, 4, 5,6, )
	);

	
	private static $fieldKeys = array (
		BasePeer::TYPE_PHPNAME => array ('Id' => 0, 'Tipcom' => 1, 'Dias' => 2, 'Documento' => 3, 'Fecha' => 4, 'Observaciones' => 5,'Estado', ),
		BasePeer::TYPE_COLNAME => array (ControlComisPeer::ID => 0, ControlComisPeer::TIPCOM => 1, ControlComisPeer::DIAS => 2, ControlComisPeer::DOCUMENTO => 3, ControlComisPeer::FECHA => 4, ControlComisPeer::OBSERVACIONES => 5,ControlComisPeer::ESTADO => 6, ),
		BasePeer::TYPE_FIELDNAME => array ('ID' => 0, 'TIPCOM' => 1, 'DIAS' => 2, 'DOCUMENTO' => 3, 'FECHA' => 4, 'OBSERVACIONES' => 5,'ESTADO' => 6, ),
		BasePeer::TYPE_NUM => array (0, 1, 2, 3, 4, 5,6,
            )
	);

	
	public static function getMapBuilder()
	{
		return BasePeer::getMapBuilder('lib.model.map.ControlComisMapBuilder');
	}
	
	public static function getPhpNameMap()
	{
		if (self::$phpNameMap === null) {
			$map = ControlComisPeer::getTableMap();
			$columns = $map->getColumns();
			$nameMap = array();
			foreach ($columns as $column) {
				$nameMap[$column->getPhpName()] = $column->getColumnName();
			}
			self::$phpNameMap = $nameMap;
		}
		return self::$phpNameMap;
	}
	
	static public function translateFieldName($name, $fromType, $toType)
	{
		$toNames = self::getFieldNames($toType);
		$key = isset(self::$fieldKeys[$fromType][$name]) ? self::$fieldKeys[$fromType][$name] : null;
		if ($key === null) {
			throw new PropelException("'$name' could not be found in the field names of type '$fromType'. These are: " . print_r(self::$fieldKeys[$fromType], true));
		}
		return $toNames[$key];
	}

	

	static public function getFieldNames($type = BasePeer::TYPE_PHPNAME)
	{
		if (!array_key_exists($type, self::$fieldNames)) {
			throw new PropelException('Method getFieldNames() expects the parameter $type to be one of the class constants TYPE_PHPNAME, TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM. ' . $type . ' was given.');
		}
		return self::$fieldNames[$type];
	}

	
	public static function alias($alias, $column)
	{
		return str_replace(ControlComisPeer::TABLE_NAME.'.', $alias.'.', $column);
	}

	
	public static function addSelectColumns(Criteria $criteria)
	{

		$criteria->addSelectColumn(ControlComisPeer::ID);

		$criteria->addSelectColumn(ControlComisPeer::TIPCOM);

		$criteria->addSelectColumn(ControlComisPeer::DIAS);

		$criteria->addSelectColumn(ControlComisPeer::DOCUMENTO);

		$criteria->addSelectColumn(ControlComisPeer::FECHA);

		$criteria->addSelectColumn(ControlComisPeer::OBSERVACIONES);
                
                $criteria->addSelectColumn(ControlComisPeer::ESTADO);

	}

	const COUNT = 'COUNT(CONTROL_COMIS.ID)';
	const COUNT_DISTINCT = 'COUNT(DISTINCT CONTROL_COMIS.ID)';

	
	public static function doCount(Criteria $criteria, $distinct = false, $con = null)
	{
				$criteria = clone $criteria;

				$criteria->clearSelectColumns()->clearOrderByColumns();
		if ($distinct || in_array(Criteria::DISTINCT, $criteria->getSelectModifiers())) {
			$criteria->addSelectColumn(ControlComisPeer::COUNT_DISTINCT);
		} else {
			$criteria->addSelectColumn(ControlComisPeer::COUNT);
		}

				foreach($criteria->getGroupByColumns() as $column)
		{
			$criteria->addSelectColumn($column);
		}

		$rs = ControlComisPeer::doSelectRS($criteria, $con);
		if ($rs->next()) {
			return $rs->getInt(1);
		} else {
						return 0;
		}
	}
	
	public static function doSelectOne(Criteria $criteria, $con = null)
	{
		$critcopy = clone $criteria;
		$critcopy->setLimit(1);
		$objects = ControlComisPeer::doSelect($critcopy, $con);
		if ($objects) {
			return $objects[0];
		}
		return null;
	}
	
	public static function doSelect(Criteria $criteria, $con = null)
	{
		return ControlComisPeer::populateObjects(ControlComisPeer::doSelectRS($criteria, $con));
	}
	
	public static function doSelectRS(Criteria $criteria, $con = null)
	{
		if ($con === null) {
			$con = Propel::getConnection(self::DATABASE_NAME);
		}

		if (!$criteria->getSelectColumns()) {
			$criteria = clone $criteria;
			ControlComisPeer::addSelectColumns($criteria);
		}

				$criteria->setDbName(self::DATABASE_NAME);

						return BasePeer::doSelect($criteria, $con);
	}
	
	public static function populateObjects(ResultSet $rs)
	{
		$results = array();
	
				$cls = ControlComisPeer::getOMClass();
		$cls = sfPropel::import($cls);
				while($rs->next()) {
		
			$obj = new $cls();
			$obj->hydrate($rs);
			$results[] = $obj;
			
		}
		return $results;
	}

  static public function getUniqueColumnNames()
  {
    return array();
  }
	
	public static function getTableMap()
	{
		return Propel::getDatabaseMap(self::DATABASE_NAME)->getTable(self::TABLE_NAME);
	}

	
	public static function getOMClass()
	{
		return ControlComisPeer::CLASS_DEFAULT;
	}

	
	public static function doInsert($values, $con = null)
	{
		if ($con === null) {
			$con = Propel::getConnection(self::DATABASE_NAME);
		}

		if ($values instanceof Criteria) {
			$criteria = clone $values; 		} else {
			$criteria = $values->buildCriteria(); 		}


				$criteria->setDbName(self::DATABASE_NAME);

		try {
									$con->begin();
			$pk = BasePeer::doInsert($criteria, $con);
			$con->commit();
		} catch(PropelException $e) {
			$con->rollback();
			throw $e;
		}

		return $pk;
	}

	
	public static function doUpdate($values, $con = null)
	{
		if ($con === null) {
			$con = Propel::getConnection(self::DATABASE_NAME);
		}

		$selectCriteria = new Criteria(self::DATABASE_NAME);

		if ($values instanceof Criteria) {
			$criteria = clone $values; 
			$comparison = $criteria->getComparison(ControlComisPeer::ID);
			$selectCriteria->add(ControlComisPeer::ID, $criteria->remove(ControlComisPeer::ID), $comparison);

		} else { 			$criteria = $values->buildCriteria(); 			$selectCriteria = $values->buildPkeyCriteria(); 		}

				$criteria->setDbName(self::DATABASE_NAME);

		return BasePeer::doUpdate($selectCriteria, $criteria, $con);
	}

	
	public static function doDeleteAll($con = null)
	{
		if ($con === null) {
			$con = Propel::getConnection(self::DATABASE_NAME);
		}
		$affectedRows = 0; 		try {
									$con->begin();
			$affectedRows += BasePeer::doDeleteAll(ControlComisPeer::TABLE_NAME, $con);
			$con->commit();
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	 public static function doDelete($values, $con = null)
	 {
		if ($con === null) {
			$con = Propel::getConnection(ControlComisPeer::DATABASE_NAME);
		}

		if ($values instanceof Criteria) {
			$criteria = clone $values; 		} elseif ($values instanceof ControlComis) {

			$criteria = $values->buildPkeyCriteria();
		} else {
						$criteria = new Criteria(self::DATABASE_NAME);
			$criteria->add(ControlComisPeer::ID, (array) $values, Criteria::IN);
		}

				$criteria->setDbName(self::DATABASE_NAME);

		$affectedRows = 0; 
		try {
									$con->begin();
			
			$affectedRows += BasePeer::doDelete($criteria, $con);
			$con->commit();
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	public static function doValidate(ControlComis $obj, $cols = null)
	{
		$columns = array();

		if ($cols) {
			$dbMap = Propel::getDatabaseMap(ControlComisPeer::DATABASE_NAME);
			$tableMap = $dbMap->getTable(ControlComisPeer::TABLE_NAME);

			if (! is_array($cols)) {
				$cols = array($cols);
			}

			foreach($cols as $colName) {
				if ($tableMap->containsColumn($colName)) {
					$get = 'get' . $tableMap->getColumn($colName)->getPhpName();
					$columns[$colName] = $obj->$get();
				}
			}
		} else {

		}

		$res =  BasePeer::doValidate(ControlComisPeer::DATABASE_NAME, ControlComisPeer::TABLE_NAME, $columns);
    if ($res !== true) {
        $request = sfContext::getInstance()->getRequest();
        foreach ($res as $failed) {
            $col = ControlComisPeer::translateFieldname($failed->getColumn(), BasePeer::TYPE_COLNAME, BasePeer::TYPE_PHPNAME);
            $request->setError($col, $failed->getMessage());
        }
    }

    return $res;
	}

	
	public static function retrieveByPK($pk, $con = null)
	{
		if ($con === null) {
			$con = Propel::getConnection(self::DATABASE_NAME);
		}

		$criteria = new Criteria(ControlComisPeer::DATABASE_NAME);

		$criteria->add(ControlComisPeer::ID, $pk);


		$v = ControlComisPeer::doSelect($criteria, $con);

		return !empty($v) > 0 ? $v[0] : null;
	}

	
	public static function retrieveByPKs($pks, $con = null)
	{
		if ($con === null) {
			$con = Propel::getConnection(self::DATABASE_NAME);
		}

		$objs = null;
		if (empty($pks)) {
			$objs = array();
		} else {
			$criteria = new Criteria();
			$criteria->add(ControlComisPeer::ID, $pks, Criteria::IN);
			$objs = ControlComisPeer::doSelect($criteria, $con);
		}
		return $objs;
	}

} 
if (Propel::isInit()) {
			try {
		BaseControlComisPeer::getMapBuilder();
	} catch (Exception $e) {
		Propel::log('Could not initialize Peer: ' . $e->getMessage(), Propel::LOG_ERR);
	}
} else {
			Propel::registerMapBuilder('lib.model.map.ControlComisMapBuilder');
}
